
//////////
// item //
//////////
datablock ItemData(TetrakaikimboakimboItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "add-ons/Weapon_Guns_Tetrakaikimbo/models/tetrakaikimbo.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiName = "Guns Tetrakaikimbo Akimbo";
	iconName = "add-ons/Weapon_Guns_Tetrakaikimbo/models/tetrakimbos.png";
	doColorShift = true;
	colorShiftColor = "0.2 1.0 0.5 1.000";
	image = TetrakaikimboakimboImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TetrakaikimboakimboImage)
{
	shapeFile = "add-ons/Weapon_Guns_Tetrakaikimbo/models/tetrakaikimbo.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; 
	rotation = eulerToMatrix( "0 0 0" );
	
	correctMuzzleVector = true;
	
	className = "WeaponImage";
	item = TetrakaikimboakimboItem;
	ammo = " ";
	projectile = AkimboGunProjectile;
	projectileType = Projectile;

	casing = GunShellDebris;
	shellExitDir		  = "1.0 -1.3 1.0";
	shellExitOffset	  = "0 0 0";
	shellExitVariance	= 15.0;	
	shellVelocity		 = 7.0;
	
	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = TetrakaikimboakimboItem.colorShiftColor;
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.2;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;
	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateName[2]                    = "Fire";
	stateScript[2]                  = "onFire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "rotate";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= TetrakaikimboFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= gunShot1Sound;
	stateEjectShell[2]       = true;
	stateName[3] = "Smoke";
	stateEmitter[3]					= TetrakaikimboSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";
	stateName[4]			= "Reload";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateTransitionOnTriggerUp[4]     = "Ready";
};

function TetrakaikimboakimboImage::onFire(%this,%obj,%slot)
{
   %obj.setImageTrigger(1,1);
   Parent::onFire(%this,%obj,%slot);
}

datablock ShapeBaseImageData(LeftHandedTetrakaikimboakimboImage)
{
   // Basic Item properties
   shapeFile = "add-ons/Weapon_Guns_Tetrakaikimbo/models/tetrakaikimbo.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = akimboGunProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

	doColorShift = true;
	colorShiftColor = TetrakaikimboakimboItem.colorShiftColor;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.2;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;
	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateName[2]                    = "Fire";
	stateScript[2]                  = "onFire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "rotate";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= TetrakaikimboFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= gunShot1Sound;
	stateEjectShell[2]       = true;
	stateName[3] = "Smoke";
	stateEmitter[3]					= TetrakaikimboSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";
	stateName[4]			= "Reload";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateTransitionOnTriggerUp[4]     = "Ready";

};


function LeftHandedTetrakaikimboakimboImage::onFire(%this, %obj, %slot)
{
   Parent::onFire(%this,%obj,%slot);
}

function TetrakaikimboakimboImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   //mount lefthanded gun
   %obj.mountImage(LeftHandedTetrakaikimboakimboImage, 1);
   //%obj.playThread(0, armreadyboth);
}
function TetrakaikimboakimboImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
   //%obj.playThread(0, root);
}


function LeftHandedTetrakaikimboakimboImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
}
function LeftHandedTetrakaikimboakimboImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
}